<?php

/*

    GTPhoto2 - A multi user photo album
    Copyright (C) 2004-2006 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

function ajax_print_table_list($edit) {

	# this is the only place where the ajax_edit variable is set
	# so that attackers can't modify a table they shoulddn't be able to
	# all edits should be checked against this variable
	if (!($_REQUEST["do_add"] && $_REQUEST["do_edit"])) {
		$_SESSION["ajax_edit"] = $edit;
	}

	$done_one = false;

	foreach ($_SESSION["ajax_edit"] as $key => $value) {
		if ($done_one) {
			echo ("&nbsp;|&nbsp;");
		}
		echo ("<a href=\"javascript:ajax_edit('".$key."')\">".$value["plural"]."</a>");
		$done_one = true;
	}
?>
<div id="ajax_edit">
<?php
if (isset($_REQUEST["id"])) {
	print ajax_print_edit_page($_REQUEST["id"]);
}
?>
</div>
<?php
}

function ajax_print_edit_page($table_id) {
	
	if (!is_numeric($table_id) || !is_array($_SESSION["ajax_edit"][$table_id])) {
		puke("Table not allowed");
	}

	# we should attempt to add/edit when the form is submitted
	if ($_REQUEST["do_add"]) {
		ajax_do_add();
	}
	if ($_REQUEST["do_edit"]) {
		ajax_do_edit();
	}

	$return = "";

	$return .= "<form action=\"index.php\">";
	$return .= "<input type=\"hidden\" name=\"next_page\" value=\"".clean_form_form($_SESSION["prev_page"])."\" />";
	$return .= "<input type=\"hidden\" name=\"id\" value=\"$table_id\" />";

	$table = $_SESSION["ajax_edit"][$table_id];
	
	print_errors();

	$return .= "<h2>Manage ".$table["plural"]."</h2>";
	$return .= "<table border=\"1\" style=\"border-collapse: collapse\"><tr>";

	$query_string = "";
	
	foreach ($table["fields"] as $key => $value) {
		$return .= "<th>".$value["name"]."</th>";
		if ($query_string != "") {
			$query_string .= ",";
		}
		$query_string .= $value["field"];

		# remember which field is the key
		if ($value["type"] == 0) {
			$key_field = $value;
		}
	}

	$return .= "</tr>";

	$SQL = "SELECT $query_string FROM ".$table["table"];
	$result = sql_query_read($SQL);

	while ($row = sql_fetch_array($result)) {
		$return .= "<tr>";
		foreach ($table["fields"] as $key => $value) {
			if ($value["type"] == 0 || $value["type"] == 1) {
				$return .= "<td>".clean_sql_display($row[$value["field"]])."</td>";
			} elseif ($value["type"] == 2) {
				$return .= "<td><input name=\"edit[".$value["field"]."][".$row[$key_field["field"]]."]\" type=\"text\" value=\"".clean_sql_form($row[$value["field"]])."\" /></td>";
			}
		}
		$return .= "</tr>";
	}

	$return .= "</table>";
	
	$return .= "<p><input type=\"submit\" name=\"do_edit\" value=\"Save\" /></p>";

	$return .= "</form>";

	$return .= "<form action=\"index.php\">";
	$return .= "<input type=\"hidden\" name=\"next_page\" value=\"".clean_form_form($_SESSION["prev_page"])."\" />";
	$return .= "<input type=\"hidden\" name=\"id\" value=\"$table_id\" />";

	$return .= "<h2>Add ".$table["name"]."</h2>";

	$return .= "<table>";
	foreach ($table["fields"] as $key => $value) {
		if ($value["type"] > 0) {
			$return .= "<tr><td>".$value["name"]."</td><td><input type=\"text\" name=\"add[".$value["field"]."]\" value=\"\" /></td></tr>";
		}
	}
	$return .= "</table>";

	$return .= "<p><input type=\"submit\" name=\"do_add\" value=\"Add\" /></p>";
	$return .= "</form>";
	
	return $return;
}

function ajax_do_edit() {

	global $errors;
	global $successes;

	$table = $_SESSION["ajax_edit"][$_REQUEST["id"]];

	$update_fields = array();

	foreach ($table["fields"] as $key => $value) {
		# this is an updatable field
		if ($value["type"] == 2) {
			array_push($update_fields, $value);
		}
		# remember which field is the key
		if ($value["type"] == 0) {
			$key_field = $value["field"];
		}
	}

	# we're going to do this the safe way
	# find the ids that we should be updating
	# and update from the list of updatable fields
	$SQL = "SELECT $key_field FROM ".$table["table"];
	$result = sql_query_read($SQL);
	$success = 0;
	while ($row = sql_fetch_array($result)) {
		$SQL = "UPDATE ".$table["table"]." SET ";
		$done_one = 0;
		# assume it validated
		$validated = 1;
		foreach ($update_fields as $key => $value) {
			$field = $_REQUEST["edit"][$value["field"]][$row[$key_field]];
			if ($value["validator"]) {
				if (!preg_match("/".$value["validator"]."/", $field)) {
					$validated = 0;
					$errors[] = $value["name"]." could not be set to ".clean_sql_display($field)." (reason: ".$value["error"].")";
					break;
				}
			}
			if ($done_one == 1) {
				$SQL .= ",";
			}
			$SQL .= $value["field"]."='".clean_form_sql($field)."'";
			$done_one = 1;
		}
		$SQL .= " WHERE $key_field='".$row[$key_field]."'";
		if ($validated) {
			sql_query_write($SQL);
			$success++;
		}
	}
	if ($success > 0) {
		$successes[] = $success." row".($success == 1 ? "" : "s")." edited";
	}
}

function ajax_do_add() {
	
	global $errors;
	global $successes;

	$table = $_SESSION["ajax_edit"][$_REQUEST["id"]];

	$update_fields = array();

	foreach ($table["fields"] as $key => $value) {
		# this is an updatable field
		if ($value["type"] > 0) {
			array_push($update_fields, $value);
		}
		# remember which field is the key
		if ($value["type"] == 0) {
			$key_field = $value["field"];
		}
	}

	# we're going to do this the safe way...
	# insert from the list of updatable fields
	# assume it worked
	$validated = 1;
	$SQL = "INSERT INTO ".$table["table"]." (";
	$done_one = 0;
	foreach ($update_fields as $key => $value) {
		if ($done_one == 1) {
			$SQL .= ",";
		}
		$SQL .= $value["field"];
		$done_one = 1;
	}
	$SQL .= ") VALUES (";
	$done_one = 0;
	foreach ($update_fields as $key => $value) {
		if ($value["validator"]) {
			if (!preg_match("/".$value["validator"]."/", $_REQUEST["add"][$value["field"]])) {
				$validated = 0;
				$errors[] = $value["name"]." could not be set to ".clean_sql_display($_REQUEST["add"][$value["field"]])." (reason: ".$value["error"].")";
				break;
			}
		}

		if ($done_one == 1) {
			$SQL .= ",";
		}
		$SQL .= "'".clean_form_sql($_REQUEST["add"][$value["field"]])."'";
		$done_one = 1;
	}
	$SQL .= ")";

	if ($validated) {
		sql_query_write($SQL);
		$successes[] = "Row added";
	}
}

?>
