<?php

/*

    GTPhoto2 - A multi user photo album
    Copyright (C) 2004-2006 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

/////////////////
// Date functions
/////////////////

/*
 * display_date_dropdown
 *
 * display a range of dropdown boxes based on the time passed in
 * what dropdowns are displayed are dependant on granularity
 *
 * $time - the unix timestamp of the date that should be displayed
 * $name - the name of the array
 * $granularity - which boxes to display: date, time, both
 *
 */

function display_date_dropdown ($time, $name, $granularity) {

        # get the actual numbers
        $day = date("j",$time);
        $month = date("n",$time);
        $year = date("Y",$time);
        $hour = date("G",$time);
        $minute = date("i",$time);

        if ($granularity == "date" || $granularity == "both" ) {
                # display the date
                echo ("<select name=\"".$name."[day]\">\n");
                for ($i = 1; $i <=31; $i++) {
                        $selected = ($i == $day)
                                ? " selected=\"selected\""
                                : $selected = "";
                        echo ("<option$selected value=\"$i\">$i</option>\n");
                }
                echo ("</select>-");
                echo ("<select name=\"".$name."[month]\">\n");
                for ($i = 1; $i <=12; $i++) {
                        $selected = ($i == $month)
                                ? " selected=\"selected\""
                                : $selected = "";
                        echo ("<option$selected value=\"$i\">".
                                # get the month string for a month number
                                date("F",mktime(1,1,1,$i,1,1)).
                                "</option>\n");
                }
                echo ("</select>-");
                echo ("<select name=\"".$name."[year]\">\n");
                for ($i = 1993; $i <= date("Y",time())+5; $i++) {
                        $selected = ($i == $year)
                                ? " selected=\"selected\""
                                : $selected = "";
                        echo ("<option$selected value=\"$i\">$i</option>\n");
                }
                echo ("</select>");
        }
        if ($granularity == "both") {
                # we need a space between the dropdowns
                echo ("&nbsp;&nbsp;");
        }

        if ($granularity == "time" || $granularity == "both") {
                # display the time
                echo ("<select name=\"".$name."[hour]\">\n");
                for ($i = 0; $i <=23; $i++) {
                        $selected = ($i == $hour)
                                ? " selected=\"selected\""
                                : $selected = "";
                        echo ("<option$selected value=\"$i\">$i</option>\n");
                }
                echo ("</select>:");
                echo ("<select name=\"".$name."[minute]\">\n");
                for ($i = 0; $i <=59; $i++) {
                        $selected = ($i == $minute)
                                ? " selected=\"selected\""
                                : $selected = "";
                        echo ("<option$selected value=\"$i\">".str_pad($i,2,"0",STR_PAD_LEFT)."</option>\n");
                }
                echo ("</select>");
        }
}
?>
