<?php

/*

    GTPhoto2 - A multi user photo album
    Copyright (C) 2004-2006 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

# This script contains the functions that have
# anything to do with logging in

function is_logged_in() {
        if (is_array($_SESSION["types"]) && count($_SESSION["types"]) > 0) {
                return true;
        } else {
                return false;
        }
}

function is_authorized($auth_level = AUTH_FREE) {

        global $errors;
        global $warnings;

        # if the auth_level session var isn't set, we need to auth
	if (!(is_array($_SESSION["types"]))
		# if types in $_SESSION doesn't have the auth_level we want, the user has to log in with someone who has it
		|| array_search($auth_level, $_SESSION["types"]) === false) {
                return false;
        } else {
                return true;
        }

}

# add the user to a category if they aren't already in the group
function add_user_type($type_id) {
	$SQL = "SELECT type_id FROM user_type_link WHERE user_id = ".$_SESSION["user_id"];
	$result = sql_query_read($SQL);
	$do_add = true;
	while ($row = sql_fetch_array($result)) {
		if ($row["type_id"] == $type_id) {
			$do_add = false;
		}
	}
	if ($do_add) {
		$SQL = "INSERT INTO user_type_link (user_id, type_id) VALUES (".$_SESSION["user_id"].", $type_id)";
		sql_query_write($SQL);
		# add it to the types for this page request, too
		$_SESSION["types"][] = $type_id;
	}
}

# function: require_login
# input: auth_level - the required authentication level
# return: none
# description: authenticate to at least the level passed in
function require_login($auth_level = AUTH_FREE) {

	global $errors;
	global $warnings;

	# if the types session var isn't set, we need to auth
	if (!is_authorized($auth_level)) {
		
		echo ("<h1>Log in</h1>");
		
                if (count($errors) == 0 && count($warnings) == 0) {
                        # if there's no errors, print the standard prompt
                        if (is_array($_SESSION["types"])) {
                                echo ("<p>The user you are logged in as does not have permissions to access this resource.  Please log in as a privileged user.</p>");
                        } else {
                                echo ("<p>You must supply a username and password to access this resource</p>");
                        }
                } else {
                        print_errors();
                }
?>
	<form action="index.php" method="post" name="login">
		<table>
		  <tr>
		    <td>User Name:</td>
		    <td><input type="text" name="user_name" value="<?=$_REQUEST["user_name"]?>" style="width: 300px" /></td>
		  </tr>
		  <tr>
		    <td>Password:</td>
		    <td><input type="password" name="password" style="width: 300px" /></td>
		  </tr>
		</table>
	<br />
<?php
	print_hidden_recursive($_REQUEST,"");
?>
	<input type="hidden" name="validator" value="login.php" />
	<input type="submit" value="Log In" />
	</form>
<?php
		if (ALLOW_SIGNUP) {
?>

	<p>If you do not yet have a Gavintech account, <a href="index.php?next_page=signup.php" target="_new">sign up</a>.</p>
		  
<?php
		}
		include("framework/footer.php");
		exit();
	}
}

function print_hidden_recursive($array,$brackets) {
        foreach ($array as $key => $value) {
                if ($brackets == "" && ($key == "user_name" || $key == "password" || $key == "PHPSESSID" || $key == "validator")) {
                        continue;
                }
                if (is_array($value)) {
                        if ($brackets == "") {
                                $temp = $key;
                        } else {
                                $temp = $brackets . "[$key]";
                        }
                        print_hidden_recursive($array[$key],$temp);
		} else {
                        if ($brackets == "") {
                                $temp = $key;
                        } else {
                                $temp = $brackets . "[$key]";
                        }
                        echo ("<input type=\"hidden\" name=\"$temp\" value=\"".clean_form_form($value)."\" />\n");
                }
        }
}

?>
